# -*- coding: utf-8 -*-
"""
Created on Mon Nov 25 19:15:39 2013

@author: jl
@author: Linus
"""

import serial
import array
import time
import struct
import math
import csv

class Gesture:
    def __init__(self,_name,_title):
        self.title=_title
        self.gesture = []
        self.captured = []
        with open(_name+'.csv', 'rb') as csvfile:
            reader = csv.reader(csvfile, delimiter=',', quotechar='|')
            for row in reader:
                self.gesture.append([int(row[0]),int(row[1]),int(row[2])])
        self.sample_length=len(self.guesture)
        self.max_distance=math.sqrt(3*self.sample_length*256**2)

    def recognize(self,v):
        self.captured.append([v[0],v[1],v[2]])
        if len(self.captured) >= self.sample_length:   
            dissimilarity = 0
            i = 0
            for point in self.captured:
                dx = (point[0]-self.gesture[i][0])**2
                dy = (point[1]-self.gesture[i][1])**2
                dz = (point[2]-self.gesture[i][2])**2
                dissimilarity += dx + dy + dz
                i += 1
            similarity = (1-math.sqrt(dissimilarity)/self.max_distance)*100
            self.captured.pop(0)
            if similarity > 91: 
                print self.title+" erkannt ! Ähnlichkeit: "+'{0:.3g}'.format(similarity)+"%"
                self.captured[:] = []
                
gestures=[
Gesture('gesture1','Drehung gegen den Uhrzeigersinn'),
Gesture('gesture2','Drehung mit dem Uhrzeigersinn'),
Gesture('gesture3','Bewegung hoch runter'),   
Gesture('gesture4','Bewegung runter hoch'),
Gesture('gesture5','Bewegung rechts links'),
Gesture('gesture6','Bewegung hinter den Kopf'),
Gesture('gesture7','Drehung des Handgelenks'),
Gesture('gesture8','Hand auf Schulter')
]
     
ser = serial.Serial(port = 4, baudrate = 115200, timeout = 1) #COM-Nummer minus 1
ser.write(array.array('B', [0xFF, 0x07, 0x03, 0x00, 0x00, 0x00, 0x00]).tostring())
ser.read(3)

print "Started reading"

for i in range(1500):
    ser.write(array.array('B', [0xFF, 0x08, 0x07, 0x00, 0x00, 0x00, 0x00]).tostring())
    accel = ser.read(7)
    if len(accel) == 7 and ord(accel[3]) == 1:      
        v = struct.unpack('bbb', accel[4:7])
        for gesture in gestures:
            gesture.recognize(v)
    time.sleep(0.03)
ser.write(array.array('B', [0xFF, 0x09, 0x03, 0x00, 0x00, 0x00, 0x00]).tostring())
ser.close()